/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");
Components.utils.import("resource://modules/SWFactory.jsm");
Components.utils.import("resource://modules/SWProfile.jsm");
Components.utils.import("resource://modules/SWUtil.jsm");

var SWG = {

  alertErrorMessage : function(sKey, aBindString) {
    SWUtil.alertErrorByKey(sKey, aBindString);
  },

  alertInfoMessage : function(sKey, aBindString) {
    SWUtil.alertInfoByKey(sKey, aBindString);
  },

  confirmMessage : function(sKey, aBindString) {
    return SWUtil.confirmByKey(sKey, aBindString);
  },

  getProperty : function(sKey, aBindString) {
    return SWFactory.getResource().getText(sKey, aBindString);
  },

  addObserver : function(object, eventName) {
    SWFactory.getHostsManager().addObserver(object, eventName);
  },

  removeObserver : function(object, eventName) {
    SWFactory.getHostsManager().removeObserver(object, eventName);
  },

  destroy : function() {
    SWFactory.getHostsManager().destroy();
  },

  getCurrentHosts : function() {
    return SWFactory.getHostsManager().getCurrentHostsFile();
  },

  getHostsList : function() {
    return SWFactory.getHostsManager().getList();
  },

  selectHosts : function(label, uri){
    SWFactory.getHostsManager().select(label, uri);
  },

  readHosts : function(uri){
    return SWFactory.getHostsManager().readFile(uri);
  },

  saveHosts : function(oHostsFile, sOperation){
    SWFactory.getHostsManager().saveFile(oHostsFile, sOperation);
  },

  removeHosts : function(sUri){
    SWFactory.getHostsManager().removeFile(sUri);
  },

  refreshDns : function(){
    SWFactory.getHostsManager().refreshDns();
  },

  changeSaveHostsPath : function(sBeforePath, sAfterPath){
    SWFactory.getHostsManager().changeSaveHostsPath(sBeforePath, sAfterPath);
  },

  changeSaveDefaultHostsPath : function(){
    return SWProfile.changeSaveDefaultHostsPath();
  },

  openUrl : function(sUrl){
    return SWProfile.openUrl(sUrl);
  },

  checkPermission : function(sFilePath){
    return SWUtil.checkPermission(sFilePath);
  },

  isAddonStarted : function(){
    return SWFactory.getHostsManager().isAddonStarted;
  },

  destroy : function(){
  },

  uninstall : function(){
    SWFactory.getHostsManager().uninstall();
  }

};
