/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");

var EXPORTED_SYMBOLS = ["PaidonPreference"];

const Cc = Components.classes;
const Ci = Components.interfaces;
var Application = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);

function PaidonPreference(branchName) {

  const supportsStringInterface = Ci.nsISupportsWString || Ci.nsISupportsString;
  this.logger = new PaidonLogger(this);

  this.branchName = branchName;

    this.prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    this.prefs = this.prefService.getBranch(this.branchName);
  this.prefBranchService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

    this.getBool = function(value){
        return this.prefs.getBoolPref(value);
    };

    this.setBool = function(name, value){
        this.prefs.setBoolPref(name, value);
    };

    this.getString = function(name){
        return this.prefs.getCharPref(name);
//return this.prefs.getComplexValue(name,supportsStringInterface).data;
    };

    this.setString = function(name, value){
        this.prefs.setCharPref(name, value);
//var string = Cc["@mozilla.org/supports-string;1"].createInstance(supportsStringInterface);
//string.data = decodeURIComponent(value);
//this.prefs.setComplexValue(name,supportsStringInterface,string);
    };

    this.exists = function(value){
        return this.prefs.prefHasUserValue(value);
    };

    this.reset = function(){
        var prefBranch = this.prefs;
        var c = {
            value: 0
        };
        var chindren = prefBranch.getChildList("", c);
        for (var i = 0; i < c.value; ++i) {
            if (prefBranch.prefHasUserValue(chindren[i])) {
                prefBranch.clearUserPref(chindren[i]);
            }
        }
    };

    this.deleteBranch = function(){
      this.prefBranchService.deleteBranch(this.branchName);
    };

};
