/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");

var EXPORTED_SYMBOLS = ["PaidonResource"];

const Cc = Components.classes;
const Ci = Components.interfaces;
var Application = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);

function PaidonResource(filePath) {

  var oBundle = Components.classes['@mozilla.org/intl/stringbundle;1'].getService(Components.interfaces.nsIStringBundleService);
  this.messageBundle = oBundle.createBundle(filePath);
  this.logger = new PaidonLogger(this);

  this.getText = function(sKey, aBindString){
    try{
      if(aBindString){
        return this.messageBundle.formatStringFromName(sKey, aBindString, aBindString.length);
      }else{
        return this.messageBundle.GetStringFromName(sKey);
      }
    }catch(e){
      this.logger.error("It failed in the acquisition of the resource. key=" + sKey);
      throw e;
    }
  };

};
