/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonFile.jsm");
Components.utils.import("resource://modules/SWConst.jsm");
Components.utils.import("resource://modules/SWFactory.jsm");
Components.utils.import("resource://modules/SWProfile.jsm");
Components.utils.import("resource://modules/SWUtil.jsm");

var EXPORTED_SYMBOLS = ["SWHostsFile", "SWHostsFileRecord"];

const Cc = Components.classes;
const Ci = Components.interfaces;
var Application = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);
var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);

function SWHostsFile() {

  this.logger = SWFactory.getLogger();
  this.resource = SWFactory.getResource();

  //
  this.records = new Array();
  this.name = "";
  this.path = "";
  this.uri = "";

  this.read = function() {
      //ǂݍ
      var file = new PaidonFile(this.path);
      var text = file.read(SWProfile.getDefaultCharset());
      if(text != null){
        var rows = text.split(SWProfile.getLineSeparator());
        var r=0;
        for(var i=0; i<rows.length; i++){
            var record = new SWHostsFileRecord(rows[i]);
            var flg = record.parse();
            if(flg) this.records[r++] = record;
        }
    }
  };

  this.write = function() {
    var outputText = "";
    for(var i=0; i<this.records.length; i++){
      outputText += this.records[i].getHostsFormattedText();
    }
    var file = new PaidonFile(this.path);
    file.write(outputText, SWProfile.getDefaultCharset());
  };

  this.apply = function() {
    var file = new PaidonFile(this.path);
    var osHostsDirPath = SWProfile.getOsHostsPath().substr(0, SWProfile.getOsHostsPath().lastIndexOf(SWProfile.getFileSeparator())+1);
    var osHostsFileName = SWProfile.getOsHostsPath().substr(SWProfile.getOsHostsPath().lastIndexOf(SWProfile.getFileSeparator())+1);

    if(!SWUtil.checkPermission(this.path)){
      return false;
    }

    if(!SWUtil.checkPermission(SWProfile.getOsHostsPath())){
      return false;
    }

    //Rs[s
    file.copy(osHostsDirPath, osHostsFileName);

    //FirefoxMenuLocationChangeŐFς邽߁AR[hǂݍ݁B
    this.read();

    return true;

  };

  this.getRecords = function() {
      return this.records;
  };

  this.setRecords = function(records) {
      this.records = records;
  };

  this.getName = function() {
      return this.name;
  };

  this.setName = function(name) {
      this.name = name;
  };

  this.getFileName = function() {
      return this.name + SWConst.HOSTS_FILE_EXT;
  };

  this.getUri = function() {
      return this.uri;
  };

  this.setUri = function(uri) {
      this.uri = uri;
  };

  this.getPath = function() {
      return this.path;
  };

  this.setPath = function(path) {
      this.path = path;
  };

  this.clone = function(){
    var oHosts = new SWHostsFile();
    oHosts.setName(this.getName());
    oHosts.setPath(this.getPath());
    oHosts.setRecords(this.getRecords());
    oHosts.setUri(this.getUri());
    return oHosts;
  }

};

function SWHostsFileRecord(text) {

  this.logger = SWFactory.getLogger();

  //CX^Xϐ
  this.text = text;
  this.ip = "";
  this.host = "";
  this.comment = "";
  this.enable = "true";

  this.parse = function() {
    //Rgs
    if(PaidonUtil.trim(this.text).substring(0,1) == "#" && PaidonUtil.trim(this.text).substring(1,4) != "sw:"){
      return false;
    }
    //s
    if(PaidonUtil.trim(this.text) == ""){
      return false;
    }
    var cols = this.text.split(/[\s\t]+/);
    if(cols.length >= 2){
      //
      if(cols[0].length >= 4 && cols[0].substring(0,1) == "#" && cols[0].substring(1,4) == "sw:"){
        this.enable = "false";
        cols[0] = cols[0].substring(4);
      }
      this.ip = cols[0];
      this.host = cols[1];
      if(cols[2] && cols[2].length >= 1 && cols[2].substring(0,1) == "#"){
        this.comment = cols[2].substring(1);
      }
    }
    return true;
  };

  this.getIp = function() {
    return this.ip;
  };

  this.setIp = function(ip) {
    this.ip = ip;
  };

  this.getHost = function() {
    return this.host;
  };

  this.setHost = function(host) {
    this.host = host;
  };

  this.isEnable = function() {
    return this.enable;
  };

  this.setEnable = function(enable) {
    this.enable = enable;
  };

  this.getComment = function() {
    return this.comment;
  };

  this.setComment = function(comment) {
    this.comment = comment;
  };

  this.getHostsFormattedText = function() {
    var line = "";
    if(this.isEnable() == "false"){
      line += "#sw:";
    }
    line += this.getIp() + " " + this.getHost();
    if(this.comment){
      line += " #" + this.getComment();
    }
    line += "\r\n";
    return line;
  };

};
