/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonFile.jsm");
Components.utils.import("resource://modules/SWConst.jsm");
Components.utils.import("resource://modules/SWFactory.jsm");

var EXPORTED_SYMBOLS = ["SWProfile"];

const Cc = Components.classes;
const Ci = Components.interfaces;
var Application = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);
var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
var navigator = wm.getMostRecentWindow('navigator:browser');
var browser = wm.getEnumerator('navigator:browser').getNext().getBrowser();

var SWProfile = {

  logger : SWFactory.getLogger(this),
  isWindows : Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS == "WINNT",
  isMac : Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS == "Darwin",
  isLinux : Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS == "Linux",

  WINDOWS_DEFALUT_HOSTS_PATH : "c:\\windows\\system32\\drivers\\etc\\hosts",
  LINUX_DEFALUT_HOSTS_PATH : "/etc/hosts",
  MAC_DEFALUT_HOSTS_PATH : "/etc/hosts",

  getSaveHostsPath : function(){
    var savePath;
    if(SWFactory.getPreference().exists("save.path")){
      savePath = SWFactory.getPreference().getString("save.path");
    }else{
      savePath = this.changeSaveDefaultHostsPath();
    }
    savePath = this.getDirectoryPath(savePath);
    return savePath;
  },

  getBackupHostsPath : function(){
    var backupPath;
    backupPath = this.getDirectoryPath(this.getOwnDirectoryPath(SWConst.MY_EXTENSION_ID)) + "switchhosts_backup";
    backupPath = this.getDirectoryPath(backupPath);
    return backupPath;
  },

  getDirectoryPath : function(path){
    if(path.lastIndexOf(this.getFileSeparator()) != path.length - this.getFileSeparator().length){
      path += this.getFileSeparator();
    }
    return path;
  },

  getFileSeparator : function(){
    if(this.isLinux || this.isMac) return "/";
    else return "\\";
  },

  getLineSeparator : function(){
    if(this.isLinux) return "\n";
    if(this.isMac) return "\r";
    return "\r\n";
  },

  changeSaveDefaultHostsPath : function(){
    var savePath = this.getDirectoryPath(this.getDirectoryPath(this.getOwnDirectoryPath(SWConst.MY_EXTENSION_ID)) + "switchhosts");
    SWFactory.getPreference().setString("save.path", savePath);
    return savePath;
  },

  getOsHostsPath : function() {
    if(this.isWindows) return this.WINDOWS_DEFALUT_HOSTS_PATH;
    if(this.isLinux) return this.LINUX_DEFALUT_HOSTS_PATH;
    if(this.isMac) return this.MAC_DEFALUT_HOSTS_PATH;
      return null;
  },

  openUrl : function(sUrl){
    browser.selectedTab = browser.addTab(sUrl + "?r=" + SWConst.MY_PRODUCT_NAME);
  },

  getDefaultCharset : function(){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    var sbService = Cc['@mozilla.org/intl/stringbundle;1'].getService(Ci.nsIStringBundleService);
    var sbCharDefault = sbService.createBundle(prefService.getDefaultBranch('intl.charset.').getCharPref('default'));
    var charset = sbCharDefault.GetStringFromName('intl.charset.default');
    return charset;
  },

  /***********************************************
  ̊g@\fBNg̃t@CpX擾
  */
  getOwnDirectoryPath : function(extensionId){
    //Profileȉ̎AhĨfBNg擾
    //nsIFileIuWFNg擾
    var myExtDir = Components.classes["@mozilla.org/extensions/manager;1"]
      .getService(Components.interfaces.nsIExtensionManager)
      .getInstallLocation(extensionId)
      .getItemLocation(extensionId);
    //N[YꂸɁI
    var fileDir = myExtDir.clone();
    //AhIfBNg牺ɂnsIFile#appendg
    //fileDir.append("chrome");
    return fileDir.parent.parent.path;

//    const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
//    try {
//      path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path;
//      return path;
//    } catch (e) {
//      alert("error");
//    }

  }

};
