/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");
Components.utils.import("resource://modules/PaidonFile.jsm");

var EXPORTED_SYMBOLS = ["SWUtil"];

const Cc = Components.classes;
const Ci = Components.interfaces;
var Application = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);

var SWUtil = {

  alertErrorByKey : function(sKey, aBindString){
    Components.utils.import("resource://modules/SWFactory.jsm");
    PaidonUtil.alert(SWFactory.getResource().getText("alert.error.title"), SWFactory.getResource().getText(sKey, aBindString))
  },

  alertInfoByKey : function(sKey, aBindString){
    Components.utils.import("resource://modules/SWFactory.jsm");
    PaidonUtil.alert(SWFactory.getResource().getText("alert.info.title"), SWFactory.getResource().getText(sKey, aBindString))
  },

  confirmByKey : function(sKey, aBindString){
    Components.utils.import("resource://modules/SWFactory.jsm");
    return PaidonUtil.confirm(SWFactory.getResource().getText("confirm.info.title"), SWFactory.getResource().getText(sKey, aBindString))
  },

  checkPermission : function(sFilePath){
    //t@C̑݁Aǂݍ݁A݌`FbN
    var file = new PaidonFile(sFilePath);
    if(!file.exists()){
      this.alertErrorByKey("error.file.notfound", [sFilePath]);
      return false;
    }
    if(!file.isReadable()){
      this.alertErrorByKey("error.file.readable", [sFilePath]);
      return false;
    }
    if(!file.isWritable()){
      this.alertErrorByKey("error.file.writable", [sFilePath]);
      return false;
    }
    return true;
  }

};
